# Testingey

`testingey` is test runner for nodejs that allows you to run tests both
sequentially or in parallel, and also supports testing of asynchronous
functions.

## Installation

```
npm install testingey
```

## Example Code

``` js
var suite = require('../lib/testingey').createSuite('Sample Tests'),
    assert = require('assert');

suite.setUp(function () {
  // setup stuff you need for testing
});

suite.tearDown(function () {
  // clean up stuff you soiled during testing
});

// create an asynch test case
suite.asyncSpec('Asynchronous and slow', function (runner) {
  setTimeout(function () {
    runner.capture(function () {
      assert.equal(5, 10);
    });
  }, 3000);
});

// a synch test case
suite.spec('Synchronous and fast', function () {
  assert.equal(1, 1);
});

suite.spec('Synchronous but slow', function () {
  for (var i = 0; i < 1000000; ++i) {}
  assert.equal(1, 1);
});

suite.asyncSpec('Asynchronous but quick', function (runner) {
  process.nextTick(function () {
    runner.capture(function () {
      assert.equal(1, 1);
    });
  });
});

suite.asyncSpec('Some nasty callback nesting', function (runner) {
  setTimeout(function () {
    process.nextTick(function () {
      runner.capture(function () {
        assert.equal(1, 5);
      });
    });
  }, 1000);
});

// run the test suite
suite.run();
```

## License

(The MIT License)

Copyright (c) 2011 Jesus A. Domingo <jesus.domingo@gmail.com>

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
