var suite = require('../lib/testingey').createSuite('Sample Tests'),
    assert = require('assert');

suite.setUp(function () {
  // setup stuff you need for testing
});

suite.tearDown(function () {
  // clean up stuff you soiled during testing
});

suite.asyncSpec('Asynchronous and slow', function (runner) {
  setTimeout(function () {
    runner.capture(function () {
      assert.equal(5, 10);
    });
  }, 3000);
});

suite.spec('Synchronous and fast', function () {
  assert.equal(1, 1);
});

suite.spec('Synchronous but slow', function () {
  for (var i = 0; i < 1000000; ++i) {}
  assert.equal(1, 1);
});

suite.asyncSpec('Asynchronous but quick', function (runner) {
  process.nextTick(function () {
    runner.capture(function () {
      assert.equal(1, 1);
    });
  });
});

suite.asyncSpec('Some nasty callback nesting', function (runner) {
  setTimeout(function () {
    process.nextTick(function () {
      runner.capture(function () {
        assert.equal(1, 5);
      });
    });
  }, 1000);
});

suite.run();
